package bankkonto;

/**
 * Title:        Bankkonto - Client
 * Description:  einfache CORBA / ORB Anwendung:
 * ein Bankserver mit mehreren Clients
 * Copyright:    Copyright (c) 2000
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */


import Bank.*;
import org.omg.CORBA.*;
import org.omg.CosNaming.*;

public class BankKunde {
  public static void main (String[] args) throws UserException {
    ORB orb = ORB.init (args, null);

    org.omg.CORBA.Object nameService_ =
      orb.resolve_initial_references ("NameService");
    NamingContext nameService = NamingContextHelper.narrow (nameService_);
    System.out.println("[BankKunde]Namenskontext wurde definiert");

    NameComponent name = new NameComponent ("Klaus Heinrich", "Konto");
    NameComponent[] path = { name };

    org.omg.CORBA.Object klausheinrich_ = nameService.resolve (path);
    Konto klausheinrich = KontoHelper.narrow (klausheinrich_);

    System.out.println ("[BankKunde]Kontostand = " + klausheinrich.kontostand ());
    System.out.println ("[BankKunde]Betrag 254.50 einzahlen");
    klausheinrich.einzahlen (254.50f);

    System.out.println ("[BankKunde]Neuer Kontostand = " + klausheinrich.kontostand());

    try {
      System.out.println ("[BankKunde]Betrag " + (klausheinrich.kontostand()+0.01f) +" abheben [mehr als auf dem Konto ist]");
      klausheinrich.abheben (klausheinrich.kontostand() + .01f);
    } catch (UngenuegenderKontostand ex) {
      System.out.println ("[BankKunde]ungenuegender Kontostand = " + ex.aktuellerKontostand);
    }

    klausheinrich_._release ();
  }
}
