package DemoAppl;

import DemoAppl.HelloApp.*;   // Stubs und Skeletons.
import org.omg.CosNaming.*;   // Nameserver

// Exceptions einbinden
import org.omg.CosNaming.NamingContextPackage.*;
import org.omg.CORBA.*; // CORBA Basisklassen

public class HelloServer
{
  public static void main(String args[])
  {
    try{

      // kreieren und initialisieren des ORB
      ORB orb = ORB.init(args, null);

      // Servant kreieren und ORB initialisieren
      HelloServant helloRef = new HelloServant();
      orb.connect(helloRef);

      // Root des Naming Kontextes
      org.omg.CORBA.Object objRef = orb.resolve_initial_references("NameService");
      NamingContext ncRef = NamingContextHelper.narrow(objRef);

      // binden des Objektes in den namensraum
      NameComponent nc = new NameComponent("Hello", " ");
      NameComponent path[] = {nc};
      ncRef.rebind(path, helloRef);

      // Clientanfragen abwarten
      java.lang.Object sync = new java.lang.Object();
      synchronized(sync){
        sync.wait();
      }

    } catch(Exception e) {
        System.err.println("ERROR: " + e);
        e.printStackTrace(System.out);
      }
  }
}



class HelloServant extends _HelloImplBase
{
  public String sayHello()
  {
    return "\nHello world!!\n";

  }
}
