// Implementationsklasse fr den Customer Agent
// Implementation der IDL Operations
//
public class KundeImpl implements Kunden {

	private Database db = null;

	public KundeImpl (Database db) {
		this.db = db;
	}


	// lies einen Kundendatensatz
	public KundenInfo liesKunde(String kundenID) throws sunw.corba.SystemException {
		KundenInfo kunde = null;
		try {
			kunde = db.liesKunde(kundenID);
		} catch (Exception e) {
			System.out.println ("[liesKunde] Exception: " + e);
		}
		return kunde;
	}

	// lies ein Array mit Customer Records
	public KundenInfo[] liesKundenListe(String nachName, String vorName) throws sunw.corba.SystemException {
		KundenInfo [] kunden = null;

		try {
			kunden = db.liesKundenListe(vorName, nachName);	
		} catch (Exception e) {
			System.out.println ("[liesKundenListe] Exception: " + e);
		}
		return kunden;
	}

	// schreib einen neuen Customer in die Datenbank
	public void schreibNeueKundenInfo(String kundenID, String nachName, String vorName, String strassenAdr) throws sunw.corba.SystemException	{
		try {
			db.schreibNeueKundenInfo(kundenID, nachName, vorName, strassenAdr);
		} catch (Exception e) {
			System.out.println ("[schreibNeueKundenInfo] Exception: " + e);
		}
	}

	// schreib einen bestehenden Customer in die Datenbank
	public void mutiereBestehendeKundenInfo(String kundenID, String nachName, String vorName, String strassenAdr) throws sunw.corba.SystemException {
		try {
			db.mutiereBestehendeKundenInfo(kundenID, nachName, vorName, strassenAdr);
		} catch (Exception e) {
			System.out.println ("[mutiereBestehendeKundenInfo] Exception: " + e);
		}
	}

	// kreiere eine Zufalss Customer ID
	public String produziereKundenID(String nachName, String vorName) throws sunw.corba.SystemException {
		char FN = Character.toUpperCase(vorName.charAt(0));
		char LN = Character.toUpperCase(nachName.charAt(0));
		// was solls
		int ID = (int)(Math.random()*1000000);
		String kundenID = new String (new StringBuffer().append(FN).append(LN).append(Integer.toString(ID)));
		return kundenID;
	}

	// Kundeninfo als Zeichenkette
	public String produziereKundenString(KundenInfo info) throws sunw.corba.SystemException {
		String KundenString = info.kundenID + "-" + info.nachName + "-" + info.vorName + "-" + info.strassenAdr;
		return KundenString;
	}
}
